#include<bits/stdc++.h>
#include<vector>
#define endl '\n'
using namespace std;
vector<long long>v[1000000];
bool used[1000000];
long long ans[1000000];
void dfs(long long vr,long long par)
{
    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i]==par)continue;
        dfs(v[vr][i],vr);
    }
    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i]==par)continue;
        ans[vr]+=ans[v[vr][i]];
    }
    ans[vr]+=1;

}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,i,j,a,b,q;

    cin>>n;

    for(i=0;i<n-1;i++)
    {
        cin>>a>>b;
        v[a].push_back(b);used[b]=1;
    }
    for(i=1;i<=n;i++)if(!used[i])break;
    dfs(i,-1);

    cin>>q;
    for(i=0;i<q;i++)
    {
        cin>>a;
        cout<<ans[a]-1<<endl;
    }
}

